/* Wingate Monitor Bot -- (c) 2001 Darcy Grexton
   Based on wgmon, (c) 1999-2001 Lucas Madar & DALnet
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>
#include "h.h"
#include "struct.h"
#include "settings.h"

char myserv[66];

#define CMD_NONE 	0
#define CMD_CHECK 	1
#define CMD_TRIGGER	2
#define CMD_REPORTCLONE	3

struct cmdstack {
	char cmd;
	char buf[128];
};

#define MAXCMD 5

struct cmdstack cmds[MAXCMD];
int cmdnum = 0;

static int showchan = 1;
static int showops = 1;

int m_reg(int parc, char *parv[])
{
	ssend("OPER %s %s\n", ONICK, OPASS);
	ssend("MODE %s +c-wsiydg\n", NICK);
	ssend
	    ("AWAY :I am a bot. Your messages will be ignored. (/msg %s INFO)\n",
	     NICK);
	if (NICKPASS[0] != '\0') {
		ssend("IDENTIFY %s\n", NICKPASS);
		if (INVCHAN[0] != '\0')
			ssend("CHANSERV INVITE %s\n", INVCHAN);
	}
	sleep(5);
	ssend("JOIN %s\n", MYCHAN);
	ssend("MODE %s +stn\n", MYCHAN);
	strcpy(myserv, parv[0]);
	cmdnum = 0;
	kill_hash();
	load_triggers();
	load_autoban();		/* load autoban list */
	load_ignore();		/* load ignore list */
	return 0;
}

/* only allow 3 messages within a 5 second period */

#define MSG_RATE 3
#define MSG_TIME 5

int check_flood(char *n, char *uh)
{
	static time_t lastmsg = 0;
	static unsigned long msgcnt = 0;

	if (lastmsg + MSG_TIME < currenttime) {
		msgcnt = 0;
		lastmsg = currenttime;
		return 0;
	}

	msgcnt++;
	lastmsg = currenttime;

	if (msgcnt == MSG_RATE) {
		ssend("LOCOPS :Warning: Possible flood initiated by %s[%s]\n",
		      n, uh);
		return 1;
	} else if (msgcnt > MSG_RATE) {
		return 1;
	}

	return 0;
}

int m_pong(int parc, char *parv[])
{
	pingstate = 0;
	return 0;
}

int m_ping(int parc, char *parv[])
{
	if (parc < 1)
		return 0;

	ssend("PONG :%s\n", parv[1]);
	return 0;
}

#define strmatch(x,y) (strncmp(x, y, strlen(y)) ? 0 : 1)
#define strcmatch(x,y) (strncasecmp(x, y, strlen(y)) ? 0 : 1)


void resolve_host(char *addr, char *dest)
{
	struct in_addr ia;
	struct hostent *he;

	if ((ia.s_addr = inet_addr(addr)) == -1) {
#ifdef RDEBUG
		ssend("PRIVMSG %s :Looking up %s...\n", dest, addr);
#endif
		he = gethostbyname(addr);
		if (!he) {
			ssend("PRIVMSG %s :Could not resolve %s.\n", dest,
			      addr);
			return;
		}
		memcpy((char *)&ia.s_addr, he->h_addr_list[0],

		       sizeof(unsigned long));

#ifdef RDEBUG
		ssend("PRIVMSG %s :Resolved %s to %s\n", dest, addr,
		      inet_ntoa(ia));
#endif
	}

	do_s5(dest, "<unknown>", ia.s_addr, addr, C_SHOW);
	do_wg(dest, "<unknown>", ia.s_addr, addr, C_SHOW);

	return;
}

char *trimspace(char *s)
{
	char *x;

	if ((x = strchr(s, ' ')))
		*x = '\0';

	return s;
}

void set_trigger(char *buf, char *nick)
{
	char *host;
	char *val;
	unsigned long rval = 0;
	Client *cp;

	host = buf;
	val = strchr(host, ' ');
	if (val) {
		*val = '\0';
		val++;
		while (*val == ' ')
			val++;
		if (*val == '\0' || (rval = strtoul(val, NULL, 0)) == 0)
			val = NULL;
	}

	cp = find_host_hash(host);

	if (!val) {
		if (!cp) {
			ssend
			    ("PRIVMSG %s :Host trigger for %s is currently not set (default is %lu)\n",
			     nick, host, DEFAULT_TRIGGER_LEVEL);
		} else {
			ssend("PRIVMSG %s :Host trigger for %s is %lu\n",
			      nick, host, cp->trigger);
		}
		return;
	}

	if (cp) {
		ssend("PRIVMSG %s :Host trigger for %s set to %lu from %lu\n",
		      nick, host, rval, cp->trigger);
		ssend
		    ("LOCOPS :%s changed host trigger for %s to %lu from %lu\n",
		     nick, host, rval, cp->trigger);
		cp->trigger = rval;
	} else {
		cp = add_host_hash(host);
		cp->cnt = 0;
		ssend("PRIVMSG %s :Host trigger for %s set to %lu from %lu\n",
		      nick, host, rval, cp->trigger);
		ssend
		    ("LOCOPS :%s changed host trigger for %s to %lu from %lu\n",
		     nick, host, rval, cp->trigger);
		cp->trigger = rval;
	}

	save_triggers();
	return;
}

int m_uhrep(int parc, char *parv[])
{
	char *uhr = parv[2];
	char *tmp;
	int oper;

	oper = 0;

	tmp = strchr(uhr, '=');
	if (!tmp) {
		if (cmdnum > 1)
			memmove((char *)&cmds[0], (char *)&cmds[1],
				sizeof(struct cmdstack) * (MAXCMD - 1));

		cmdnum--;
		return 0;
	}

	if (*(tmp - 1) == '*') {
		oper = 1;
		tmp--;
	}

	*tmp = '\0';

	if (!oper)
		ssend("PRIVMSG %s :You are not an irc operator. Go away.\n",
		      uhr);
	else {
		switch (cmds[0].cmd) {
		case CMD_CHECK:
			resolve_host(cmds[0].buf, uhr);
			break;

		case CMD_TRIGGER:
			set_trigger(cmds[0].buf, uhr);
			break;

		case CMD_REPORTCLONE:
			showops = showops ? 0 : 1;
			ssend
			    ("LOCOPS :%s toggled locops clone reporting to %s.\n",
			     uhr, showops ? "on" : "off");
			break;

		default:
			break;
		}
	}

	if (cmdnum > 1)
		memmove((char *)&cmds[0], (char *)&cmds[1],
			sizeof(struct cmdstack) * (MAXCMD - 1));

	cmdnum--;

	return 0;
}

int handle_chan(char *nick, char *user, char *m, char *domain, char *to)
{
	char *msg, *q;
	int l;

	/* if message is prefixed with all or first x letters of my servername, process it. */

	q = m;
	while (*q != ' ' && *q != '\0')
		q++;

	if (*(q - 1) == ':' || *(q - 1) == ',') {
		q--;
		*q = ' ';
	}

	l = q - m;

	msg = q;

	if (strncasecmp(m, myserv, (l > 3) ? l : 3) && strncmp(m, "!all ", 5))
		return 0;

	while (*msg == ' ')
		msg++;

	if (!*msg) {
		ssend
		    ("PRIVMSG %s :A command would be nice when you address me, you know..\n",
		     to);
		return 0;
	}

	if (strncasecmp(msg, "STAT", 4) == 0) {
		show_stats(to);
		return 0;
	}

	if (strncasecmp(msg, "REPORTCLONE", 11) == 0) {
		char *txt = msg + 11;

		while (*txt == ' ')
			txt++;
		trimspace(txt);

		if (strcasecmp(txt, "ON") == 0)
			showchan = 1;
		else if (strcasecmp(txt, "OFF") == 0)
			showchan = 0;
		else {
			ssend
			    ("PRIVMSG %s :You must specify either reportclone ON or OFF.\n",
			     to);
			return 0;
		}

		ssend
		    ("PRIVMSG %s :Clone warning to channel set to %s by %s\n",
		     MYCHAN, showchan ? "on" : "off", nick);

		return 0;
	}

	if (strncasecmp(msg, "MEM", 3) == 0) {
		show_memstats(to);
		return 0;
	}

	if (strncasecmp(msg, "MATCH", 5) == 0) {
		char *txt = msg + 5;

		while (*txt == ' ')
			txt++;
		trimspace(txt);
		if (*txt != '\0')
			match_host(to, txt);
		return 0;
	}

	if (strncasecmp(msg, "HSTAT", 5) == 0) {
		hash_stat(to);
		return 0;
	}

	if (strncasecmp(msg, "HRESET", 6) == 0) {
		kill_hash();
		ssend("PRIVMSG %s :Hash tables reset.\n", MYCHAN);
		return 0;
	}

	if (strncasecmp(msg, "CHECK", 5) == 0) {
		char *txt = msg + 5;

		while (*txt == ' ')
			txt++;
		trimspace(txt);
		if (*txt != '\0') {
			resolve_host(txt, MYCHAN);
		}
		return 0;
	}

	if (strncasecmp(msg, "CLONE", 5) == 0) {
		char *txt = msg + 5;

		while (*txt == ' ')
			txt++;
		trimspace(txt);
		if (*txt) {
			int cnt = find_host_hash_cnt(txt);

			ssend("PRIVMSG %s :%d users on %s from host %s\n", to,
			      cnt, myserv, txt);
		}
		return 0;
	}

/* security risk, smecurity risk! :P
	if(strncasecmp(msg, "LOCOP", 5) == 0)
	{
		char *txt = msg + 5;
		while(*txt == ' ')
			txt++;

		if(!*txt)
			return 0;

		ssend("LOCOPS :[%s]: %s\n", nick, txt);

		return 0;
	}
*/
	ssend("PRIVMSG %s :I don't know how to %s, %s.\n", to, msg, nick);

	return 0;
}

int handle_ctcp(char *nick, char *user, char *msg, char *domain)
{
	char *tmp;

	msg++;

	while ((tmp = index(msg, '\001')))
		*tmp = '\0';

	if (strmatch(msg, "PING")) {
		ssend("NOTICE %s :\001%s\001\n", nick, msg);
		return 0;
	}

	if (strmatch(msg, "VERSION")) {
		ssend
		    ("NOTICE %s :\001VERSION WGMon %d.%d.%d\001\n",
		     nick, MAJOR, MINOR, PATCH);
		return 0;
	}

	return 0;
}

char *infos[] = {
	"This bot scans incoming connections for the presence of Wingate/SOCKS servers. These "
	"servers are not welcome on HabberNet due to abuse. By using HabberNet, you are agreeing "
	"to this scan.",

	"Please E-Mail abuse@habber.net if you have any questions.",
	NULL
};

int m_client_conn(char *msg, int len)
{
	char *x, *n, *p, *k, *u;
	Client *cp;
	unsigned long now;

	x = &msg[len];

	while (*x != ']' && len) {
		x--;
		len--;
	}

	*x = '\0';

	while (*x != '[' && len) {
		x--;
		len--;
	}

	x++;

	k = p = &msg[33];

	while (*p != ' ' && *p != '\0')
		p++;

	*p = '\0';
	p += 2;

	u = p;

	while (*p != '@' && *p != '\0')
		p++;

	if (*p == '\0')
		return 0;

	*p = '\0';
	n = ++p;

	while (*n != ')' && *n != '\0')
		n++;

	if (*n == '\0')
		return 0;

	*n = '\0';

	now = currenttime;

	cp = add_host_hash(p);

	if (cp->flags & HOST_IGNORE)
		return 0;	/* doo be doo be doooo.. */

	if (cp->flags & HOST_AUTOB) {
		ssend("KLINE %d *@%s :%s\n", KLINETIME, p, AUTOBAN_REASON);
		return 0;
	}

	if (cp->cnt == 1)
		/* only on one client at a time -- save CPU and cycles, as well as multiple connects */
		do_s5(k, u, inet_addr(x), p, C_NORM);
	else {
#ifdef CLONE_ALERTS
		if (cp->cnt >= cp->trigger && !(cp->cnt % 5)) {
			if ((cp->lastval != cp->cnt)
			    || (cp->lastrep + CLONE_ALERT_TIME <= now)) {
				cp->lastrep = now;
				cp->lastval = cp->cnt;
				if (showchan)
					ssend
					    ("PRIVMSG %s :%d clones from %s\n",
					     MYCHAN, cp->cnt, p);
				if (showops)
					ssend("LOCOPS :%d clones from %s\n",
					      cp->cnt, p);
			}
		}
#endif
#ifdef AUTO_CLONE_KLINING
		if ((cp->cnt >= (cp->trigger + AUTO_KLINE_LEVEL))
		    && ((now - cp->last1) <= CLONE_TIME_APART)
		    && ((cp->last1 - cp->last2) <= CLONE_TIME_APART)
		    && ((cp->last2 - cp->last3) <= CLONE_TIME_APART)
		    && ((cp->last3 - cp->last4) <= CLONE_TIME_APART)) {
			if (!(cp->flags & HOST_KLINED)) {
				ssend("LOCOPS :Auto-KLine activated for %s\n",
				      p);
				ssend("KLINE %d *@%s :%s\n", KLINETIME, p,
				      CLONE_KLINE_REASON);
				cp->flags |= HOST_KLINED;
			}
		}
#endif

	}

	cp->last4 = cp->last3;
	cp->last3 = cp->last2;
	cp->last2 = cp->last1;
	cp->last1 = now;

	return 0;
}

int m_client_exit(char *msg, int len)
{
	char *p, *n;

	p = &msg[30];

	while (*p != '@' && *p != '\0')
		p++;

	if (*p == '\0')
		return 0;

	*p = '\0';
	n = ++p;

	while (*n != ')' && *n != '\0')
		n++;

	if (*n == '\0')
		return 0;

	*n = '\0';

	del_host_hash(p);

	return 0;
}

int m_serv_msg(char *msg)
{
	int len = strlen(msg) - 1;

	if (len < 23)
		return 0;

	if (msg[21] == 'c' && msg[22] == 'o' && msg[len] == '}')
		return m_client_conn(msg, len);

	if (msg[21] == 'e' && msg[22] == 'x' && msg[len] == ']')
		return m_client_exit(msg, len);

	return 0;
}

void checkoper(char *nick, char *msg, int type)
{
	if (cmdnum >= MAXCMD) {
		ssend
		    ("PRIVMSG %s :Too many active queries, try again later.\n");
		return;
	}

	cmds[cmdnum].cmd = type;
	strncpy(cmds[cmdnum].buf, msg, 127);
	cmdnum++;

	ssend("USERHOST %s\n", nick);
}

int m_invite(int parc, char *parv[])
{
	char *to = parv[2];
	char clist[64];
	int die = 0;
	char *c = clist, *cn = clist;

	if (parc < 2)
		return 0;

	strcpy(clist, MYCHAN);

	while (!die) {
		if (*c == ',' || !*c) {
			if (!*c)
				die++;
			else
				*c = '\0';
#ifdef CDEBUG
			printf("to: %s cn: %s\n", to, cn);
#endif

			if (strcasecmp(to, cn) == 0) {
				ssend("JOIN %s\n", to);
				return 0;
			}
			cn = c + 1;
		}
		c++;
	}

	return 0;
}

int m_privmsg(int parc, char *parv[])
{

/*	int i;*/
	char *sender = parv[0];
	char *to = parv[1];
	char *msg = parv[2];
	char *nick, *user, *uptr;
	char *domain = NULL;
	char uid[11];
	int ulen;		/*, pd; */

	nick = sender;
	if (!nick)
		return 0;

	user = index(sender, '!');
	if (!user) {
		if (index(sender, '.'))	// is server
		{
			if (msg)
				return m_serv_msg(parv[2]);
		}
		return 0;
	}

	*user = '\0';
	user++;

	if (*user == '~')
		user++;

	uptr = index(user, '@');
	if (!uptr)
		return 0;

/* This code is absolutely useless at the moment. We don't need the domain.
	ulen = strlen(user);

	for(i = ulen, pd = 0;;i--)
	{
		if(user[i] == '@')
		{
			domain = &user[i+1];
			break;
		}

		if(user[i] == '.')
			if(pd)
			{
				domain = &user[i+1];
				break;
			}
			else
				pd = 1;
		
	}
*/

	ulen = uptr - user;

	memcpy((char *)&uid, user, ulen);
	uid[ulen] = '\0';

	if (!msg)
		return 0;

	if (*to == '$') {
		/* Message is to a server */
		return 0;
	}

	if ((*to != '#') && check_flood(nick, user))
		return 0;

	if (*msg == '\001') {
		/* Message is a CTCP */
		return handle_ctcp(nick, user, msg, domain);
	}

	if (*to == '#')
		return handle_chan(nick, user, msg, domain, to);

	if (strncasecmp(msg, "STAT", 4) == 0) {
		show_stats(nick);
		return 0;
	}

	if (strncasecmp(msg, "CHECK", 5) == 0) {
		char *txt = msg + 5;

		while (*txt == ' ')
			txt++;
		trimspace(txt);
		if (*txt != '\0')
			checkoper(nick, txt, CMD_CHECK);
		return 0;
	}

	if (strncasecmp(msg, "REPORTCLONE", 11) == 0) {
		checkoper(nick, msg + 11, CMD_REPORTCLONE);
		return 0;
	}

	if (strncasecmp(msg, "TRIGGER", 7) == 0) {
		char *txt = msg + 7;

		while (*txt == ' ')
			txt++;
		if (*txt != '\0')
			checkoper(nick, txt, CMD_TRIGGER);
		return 0;
	}

	if (strncasecmp(msg, "INFO", 4) == 0) {
		int i = 0;
		char *sm;

		while ((sm = infos[i++]))
			ssend("NOTICE %s :%s\n", nick, sm);
		return 0;
	}

	return 0;
}
