/* Wingate Monitor Bot -- (c) 2001 Darcy Grexton
   Based on wgmon, (c) 1999-2001 Lucas Madar & DALnet
 */

/* Structure for a host being scanned? */
struct fdi {
    char status;	/* Status byte: one of the S_xxxx states */
    char flags;		/* Flags and stuff */
    char h[66];		/* Hostname */
    char n[32];		/* nickname */
    char u[12];		/* username */
    unsigned long ip;	/* IP */
    time_t ott;		/* Time until timeout */
};

/* Client structure.. ? */
struct client {
    int cnt;
    char host[66];		/* inefficient. Oh well. */
    unsigned long flags;	/* client flags */
    unsigned long trigger;	/* trigger value */
    unsigned long last1;	/* last time we got a connection from this host */
    unsigned long last2;	/* and one more before that.. */
    unsigned long last3;	/* and one more before that.. */
    unsigned long last4;	/* and one more before that.. */
    unsigned long lastrep;	/* last clone report time */
    unsigned long lastval;	/* number of clones at this time */
    struct client *hnext;
    struct client *hprev;
    struct client *next;
    struct client *prev;
};

typedef struct client Client;

/* status states */
#define S_FREE 		0	/* Socket is not used */
#define S_S4_NEGOTIATE	1	/* Socket is waiting for connect() to complete - s4 */
#define S_S4_REPLYWAIT 	2	/* Socket is waiting for a return to read() - s4 */
#define S_WG_NEGOTIATE 	3	/* Socket is waiting for connect() to compete - wg */
#define S_WG_REPLYWAIT 	4	/* Socket is waiting for a return to read() - wg */
#define S_WG_INFOWAIT 	5	/* Waiting for a second wg buffer.. */
#define S_S5_NEGOTIATE	6	/* Waiting for a connect() - s5 */
#define S_S5_REPLYWAIT	7	/* waiting for a return to read() - s5 */

#define IsNegotiating(x) (locals[x].status == S_S4_NEGOTIATE || locals[x].status == S_WG_NEGOTIATE || \
                          locals[x].status == S_S5_NEGOTIATE)
#define StatNegotiating(x) (x == S_S4_NEGOTIATE || x == S_WG_NEGOTIATE || \
                            x == S_S5_NEGOTIATE)
#define IsDoingS4(x) ((locals[x].status > 0) && (locals[x].status < 3))
#define IsDoingS5(x) ((locals[x].status > 2) && (locals[x].status < 6))
#define IsDoingWG(x) ((locals[x].status > 5) && (locals[x].status < 8))
#define IsStatS4(x) ((x > 0) && (x < 3))
#define IsStatS5(x) ((x > 2) && (x < 6))
#define IsStatWG(x) ((x > 5) && (x < 8))
#define IsWaiting(x) ((locals[x].status > 0 && locals[x].status < 8) && !IsNegotiating(x))
#define StatWaiting(x) ((x > 0 && x < 8) && !StatNegotiating(x))

/* flags */
#define F_SHOW 		0x01	/* Show to MYCHAN */
#define F_MANUAL	0x02	/* Don't progress to wingate checking, this is manual */
#define F_OPEN1080	0x04	/* Port 1080 is open on this host. */

#define C_NORM 0		/* normal auto check */
#define C_SHOW 1		/* asked to show results to channel */

#define HOST_KLINED 0x01	/* We've klined this host */
#define HOST_IGNORE 0x02	/* We want to ignore this host and everything about it. */
#define HOST_AUTOB  0x04	/* We automatically ban this host */

#define KEEP_FLAGS  (HOST_IGNORE | HOST_AUTOB)
